import pygame
import numpy as np
import requests
import json
import sys

pygame.init()
clock = pygame.time.Clock()
inmenu = True
pos = 0
ingame = True
win = 0
FPS = 30
playtime = 0.0


size = width, height = 500, 500
screen = pygame.display.set_mode(size)
menu_ui = pygame.Surface((500,500))
#board_ui.fill((115,135,132))
screen.blit(menu_ui, (0,0))
pygame.display.set_caption('TIC TACTICS')
menugroup = pygame.sprite.Group()
symbolgroup = pygame.sprite.Group()
selectiongroup = pygame.sprite.Group()
wingroup = pygame.sprite.Group()

class Menu(pygame.sprite.Sprite):
    image = pygame.image.load("images\menu.png")
    image = image.convert_alpha()

    def __init__(self):
       pygame.sprite.Sprite.__init__(self, menugroup)
       self.rect = (0,0)


class Menu_Select(pygame.sprite.Sprite):
    image = pygame.image.load("images\menu_select.png")
    image = image.convert_alpha()

    def __init__(self,pos):
       pygame.sprite.Sprite.__init__(self, menugroup)
       self.rect = (88+96*pos,262)

class Menu_Load(pygame.sprite.Sprite):
    image = pygame.image.load("images\loading.png")
    image = image.convert_alpha()

    def __init__(self):
       pygame.sprite.Sprite.__init__(self, menugroup)
       self.rect = (0,0)



class Cross(pygame.sprite.Sprite):
    image = pygame.image.load("images\cross.png")
    image = image.convert_alpha()

    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, symbolgroup)
       self.rect = (x*51+20, y*51+20)

class Circle(pygame.sprite.Sprite):
    image = pygame.image.load("images\circle.png")
    image = image.convert_alpha()

    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, symbolgroup)
       self.rect = (x*51+20, y*51+20)

class Selection(pygame.sprite.Sprite):
    image = pygame.image.load("images\select.png")
    image = image.convert_alpha()
    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, selectiongroup)
       self.rect = (x*51+20, y*51+20)

class Selection_Cross(pygame.sprite.Sprite):
    image = pygame.image.load("images\select_cross.png")
    image = image.convert_alpha()
    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, selectiongroup)
       self.rect = (x*51+20, y*51+20)

class Selection_Circle(pygame.sprite.Sprite):
    image = pygame.image.load("images\select_circle.png")
    image = image.convert_alpha()
    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, selectiongroup)
       self.rect = (x*51+20, y*51+20)

class Cross_Win(pygame.sprite.Sprite):
    image = pygame.image.load("images\cross_win.png")
    image = image.convert_alpha()
    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, wingroup)
       self.rect = (x*153+20, y*153+20)

class Circle_Win(pygame.sprite.Sprite):
    image = pygame.image.load("images\circle_win.png")
    image = image.convert_alpha()
    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, wingroup)
       self.rect = (x*153+20, y*153+20)

class Cross__Win_Big(pygame.sprite.Sprite):
    image = pygame.image.load("images\cross_win_big.png")
    image = image.convert_alpha()
    def __init__(self):
       pygame.sprite.Sprite.__init__(self, wingroup)
       self.rect = (5, 5)

class Circle__Win_Big(pygame.sprite.Sprite):
    image = pygame.image.load("images\circle_win_big.png")
    image = image.convert_alpha()
    def __init__(self):
       pygame.sprite.Sprite.__init__(self, wingroup)
       self.rect = (5, 5)

class Selection_Cross_Big(pygame.sprite.Sprite):
    image = pygame.image.load("images\select_cross_big.png")
    image = image.convert_alpha()
    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, selectiongroup)
       self.rect = (10+153*x, 10+153*y)

class Selection_Circle_Big(pygame.sprite.Sprite):
    image = pygame.image.load("images\select_circle_big.png")
    image = image.convert_alpha()
    def __init__(self, x, y):
       pygame.sprite.Sprite.__init__(self, selectiongroup)
       self.rect = (10+153*x, 10+153*y)

def drawcross(color, x, y):
    pygame.draw.line(screen, color, (x-120, y), (x-40, y))
    pygame.draw.line(screen, color, (x+40, y), (x+120, y))
    pygame.draw.line(screen, color, (x, y-120), (x, y-40))
    pygame.draw.line(screen, color, (x, y+40), (x, y+120))

def shrink_coordinates(x,y,current_board= None):
    row = 0
    column = 0

    if x > 2 and x < 6:
        column = 1
    elif x > 2:
        column = 2

    if y > 2 and y < 6:
        row = 1
    elif y > 2:
        row = 2


    x_new = x-3*column
    y_new = y-3*row

    try:
        if current_board == None:
            return [row, column]

    except:
        board_small = np.ndarray(shape=(3, 3), dtype=int)
        for i in range(3):
            for j in range(3):
                board_small[j, i] = current_board[3 * column + i, 3 * row + j]

        return row, column, x_new, y_new, board_small

while inmenu:
    milliseconds = clock.tick(FPS)  # do not go faster than this frame rate
    seconds = milliseconds / 1000.0
    playtime += seconds

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            inmenu = False
            ingame = False
            break

        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_ESCAPE:
                inmenu = False
                ingame = False
                break

            if event.key == pygame.K_SPACE:
                inmenu = False
                break

    menugroup.empty()
    Menu()
    Menu_Select(pos)

    menugroup.draw(screen)
    pygame.display.update()


if pos == 0:
    online = False
    AI = False

elif pos == 1:
    online = True
    AI = False

    Menu_Load()

    menugroup.draw(screen)
    pygame.display.update()


else:
    online = False
    AI = True

if not ingame:
    sys.exit()

if AI:
    import random
    from tensorflow import keras
    from tensorflow.keras import layers
    from collections import deque


    class Board():
        def __init__(self):
            """
            board: 9 x 9 numpy array, 0: neutral, 1: cross, 2: circle
            turn: indexed turn, uneven is cross' turn, even is circle's
            """

            self.board = np.zeros((9, 9), dtype=int)
            self.checkboard = np.zeros((3, 3), dtype=int)
            self.turn = 0
            self.legal = [1, 1]
            self.win = 0
            self.impossible = False
            self.active = [0, 0]
            Selection(0, 0)

        def reset(self):
            self.board = np.zeros((9, 9), dtype=int)
            self.checkboard = np.zeros((3, 3), dtype=int)
            self.turn = 0
            self.legal = [1, 1]
            self.win = 0
            self.impossible = False
            self.active = [0, 0]
            Selection(0, 0)

        def get_board(self):
            return self.board

        def get_legal(self):
            return self.legal

        def get_win(self):
            return self.win

        def get_impossible(self):
            return self.impossible

        def get_active(self):
            return self.active

        def observe(self, faction):
            """
            faction: faction of observer, 1: cross, 2: circle
            """
            observation = np.zeros((9, 9), dtype=float)

            for (x, y), value in np.ndenumerate(self.get_board()):
                if value == 0:
                    observation[x, y] = 0.5
                elif value == faction:
                    observation[x, y] = 1
                else:
                    observation[x, y] = 0

            return observation

        def check(self, board, x, y, small):
            """
            Take care, x and y are on the 3x3
            Call before changing legal 3x3!
            small: boolean, true if checking on big field
            """
            field_win = False
            x, y = int(x), int(y)
            l_y, l_x = int(self.get_legal()[0]), int(self.get_legal()[1])
            if self.checkboard[l_x, l_y] != 0 and small:
                return field_win

            if board[0, y] == board[1, y] == board[2, y]:
                self.checkboard[l_x, l_y] = board[x, y]
                field_win = True

            if board[x, 0] == board[x, 1] == board[x, 2]:
                self.checkboard[l_x, l_y] = board[x, y]
                field_win = True

            if x == y and board[0, 0] == board[1, 1] == board[2, 2]:
                self.checkboard[l_x, l_y] = board[x, y]
                field_win = True

            if x + y == 2 and board[0, 2] == board[1, 1] == board[2, 0]:
                self.checkboard[l_x, l_y] = board[x, y]
                field_win = True

            if field_win and small:
                print(l_x, l_y)
                if self.check(self.checkboard, l_x, l_y, False):
                    print(self.turn)
                    self.win = (self.turn % 2) + 1


            return field_win

        def step(self, moves, faction):
            observation = self.observe(faction)
            reward = 0
            not_moved = True
            i = 0
            while not_moved:
                move = moves[i]
                print(move)
                x_small = move % 3
                y_small = np.floor(move / 3)
                print(x_small, y_small)

                x = int(x_small + self.get_legal()[1] * 3)
                y = int(y_small + self.get_legal()[0] * 3)
                print(x, y)

                if self.board[x, y] != 0:
                    i += 1
                    if i == 9:
                        self.impossible = True
                        reward = -1
                        observation_new = self.observe(faction)
                        move = 0
                        break

                else:
                    self.board[x, y] = 1 + (self.turn % 2)
                    # zooming in on just altered 3 by 3
                    small_board = self.get_board()[int(self.get_legal()[1] * 3):int(self.get_legal()[1] * 3 + 3),
                                  int(self.get_legal()[0] * 3):int(self.get_legal()[0] * 3 + 3)]

                    print(self.get_legal()[1] * 3)
                    print(small_board)
                    self.check(small_board, x_small, y_small, True)
                    if self.get_win(): reward += 10

                    self.legal = [y_small, x_small]

                    observation_new = self.observe(faction)

                    self.turn += 1
                    not_moved = False

            return observation, observation_new, reward, move

        def update(self):
            wingroup.empty()
            for i in range(3):
                for j in range(3):
                    if win == 1:
                        Cross__Win_Big()
                    elif self.checkboard[i, j] == 1:
                        wingroup.add(Cross_Win(i, j))

                    if win == 2:
                        Circle__Win_Big()
                    elif self.checkboard[i, j] == 2:
                        wingroup.add(Circle_Win(i, j))

            symbolgroup.empty()
            for i in range(9):
                for j in range(9):
                    if self.board[i, j] == 1:
                        symbolgroup.add(Cross(i, j))
                    elif self.board[i, j] == 2:
                        symbolgroup.add(Circle(i, j))

        def update_active(self, position):
            self.active = position

        def show_active(self):
            column, row = self.get_legal()

            selectiongroup.empty()

            if self.turn % 2 == 0:
                Selection_Cross_Big(row, column)

            if self.turn % 2 == 1:
                Selection_Circle_Big(row, column)

            if self.board[self.active[0], self.active[1]] == 1:
                Selection_Cross(self.active[0], self.active[1])
            elif self.board[self.active[0], self.active[1]] == 2:
                Selection_Circle(self.active[0], self.active[1])
            else:
                Selection(self.active[0], self.active[1])

    board = Board()
    in_control = True

    model = keras.models.load_model('AI/ticbot.h5')

    board_ui = pygame.Surface((500, 500))
    # board_ui.fill((115,135,132))
    screen.blit(board_ui, (0, 0))

    while ingame:
        milliseconds = clock.tick(FPS)  # do not go faster than this frame rate
        seconds = milliseconds / 1000.0
        playtime += seconds

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                ingame = False

            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    ingame = False
                if event.key == pygame.K_SPACE and board.get_board()[board.get_active()[0], board.get_active()[1]] == 0 and (shrink_coordinates(board.get_active()[0],board.get_active()[1]) == board.get_legal()) and in_control:
                    x_s, y_s = shrink_coordinates(board.get_active()[0], board.get_active()[1], board.get_board())[2], shrink_coordinates(board.get_active()[0], board.get_active()[1], board.get_board())[3]
                    moves = [x_s+y_s*3,0,0,0,0,0,0,0]
                    board.step(moves,(board.turn % 2) + 1)
                    in_control = False



                if event.key == pygame.K_DOWN and board.get_active()[1] < 8:
                    board.update_active([board.get_active()[0], board.get_active()[1] + 1])
                elif event.key == pygame.K_UP and board.get_active()[1] > 0:
                    board.update_active([board.get_active()[0], board.get_active()[1] - 1])

                if event.key == pygame.K_RIGHT and board.get_active()[0] < 8:
                    board.update_active([board.get_active()[0] + 1, board.get_active()[1]])
                elif event.key == pygame.K_LEFT and board.get_active()[0] > 0:
                    board.update_active([board.get_active()[0] - 1, board.get_active()[1]])



        if not in_control:
            observation = board.observe((board.turn % 2) + 1)
            obs = np.expand_dims(observation, axis=0)  # (Formatting issues) Making the observation the first element of a batch of inputs
            Q = model.predict(obs)[0]  # Q-values predictions
            Q = Q.tolist()
            print(Q)
            actions = np.argsort(Q)[::-1]
            board.step(actions, (board.turn % 2) + 1)

            in_control = True

        board.show_active()
        win = board.get_win()

        screen.fill((200, 200, 200))

        """
        pygame.draw.line(screen, (88, 95, 98), (20, 174), (480, 174))
        pygame.draw.line(screen, (88, 95, 98), (20, 326), (480, 326))
        pygame.draw.line(screen, (88, 95, 98), (171, 20), (171, 480))
        pygame.draw.line(screen, (88, 95, 98), (325, 20), (325, 480))
        """
        drawcross((34, 32, 52), 171, 171)
        drawcross((34, 32, 52), 325, 325)


        symbolgroup.clear(screen, screen)
        if win == 0:
            selectiongroup.update(seconds)
            selectiongroup.draw(screen)

        elif win == 1:
            Cross__Win_Big()

        else:
            Circle__Win_Big()

        board.update()
        symbolgroup.update(seconds)
        symbolgroup.draw(screen)
        selectiongroup.clear(screen, screen)


        wingroup.clear(screen, screen)
        wingroup.update(seconds)
        wingroup.draw(screen)
        pygame.display.update()




if online:
    uuid = requests.get('XXXXXXXXXXXXXXXXXXXXXXXXX')  # !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    uuid = json.loads(uuid.text)['uuid']
    status_r = requests.get('XXXXXXXXXXXXXXXXXXXXXXXXXX')
    status = json.loads(status_r.text)
    if uuid == status['player1']:
        player_num = 2
    else:
        player_num = 1

def empty_board():
    board = np.ndarray(shape=(9,9), dtype=int)
    for i in range(9):
        for j in range(9):
            board[i,j] = 0

    board_check = np.ndarray(shape=(3,3), dtype=int)
    for i in range(3):
        for j in range(3):
            board_check[i,j] = 0

    return board, board_check

def check(x, y, current_board, check_board):
    row, column, x_new, y_new, board_small = shrink_coordinates(x, y, current_board)

    if check_board[column, row] != 0:
        return check_board

    val = board_small[y_new, x_new]

    if val == board_small[y_new,0] and val == board_small[y_new,1] and val == board_small[y_new,2]:
        if val == 1:
            check_board[column, row] = 1
        if val == 2:
            check_board[column, row] = 2


    elif val == board_small[0,x_new] and val == board_small[1,x_new] and val == board_small[2,x_new]:
        if val == 1:
            check_board[column, row] = 1
        if val == 2:
            check_board[column, row] = 2


    if x_new == y_new:
        if val == board_small[0,0] and val == board_small[1,1] and val == board_small[2,2]:
            if val == 1:
                check_board[column, row] = 1
            if val == 2:
                check_board[column, row] = 2

    if x_new + y_new == 2:
        if val == board_small[0,2] and val == board_small[1,1] and val == board_small[2,0]:
            if val == 1:
                check_board[column, row] = 1
            if val == 2:
                check_board[column, row] = 2

    return check_board

def check_all(board_small, win):
    for i in range(3):
        if board_small[i, 0] == board_small[i, 1] and board_small[i, 1] == board_small[i, 2]:
            if board_small[i, 0] == 1:
                win = 1
            if board_small[i, 0] == 2:
                win = 2

        if board_small[0, i] == board_small[1, i] and board_small[1, i] == board_small[2, i]:
            if board_small[0, i] == 1:
                win = 1
            if board_small[0, i] == 2:
                win = 2

    if (board_small[0,0] == board_small[1,1] == board_small[2,2]) or (board_small[0,2] == board_small[1,1] == board_small[2,0]):
        if board_small[1, 1] == 1:
            win = 1
        if board_small[1, 1] == 2:
            win = 2


    return win




    """
    elif val == board_small[0,x_new] and val == board_small[1,x_new] and val == board_small[2,x_new]:
        if val == 1:
            check_board[column, row] = 1
        if val == 2:
            check_board[column, row] = 2
    """

board_ui = pygame.Surface((500,500))
#board_ui.fill((115,135,132))
screen.blit(board_ui, (0,0))

class Board_UI(pygame.sprite.Sprite):

    def __init__(self):
       self.board = empty_board()[0]
       self.check_board = empty_board()[1]
       self.active = [0,0]
       Selection(0,0)

    def update_active(self, position):
       self.active = position


    def show_active(self):
        column, row = legal_three_by_three

        selectiongroup.empty()

        if turn % 2 == 0:
            Selection_Cross_Big(row, column)

        if turn % 2 == 1:
            Selection_Circle_Big(row, column)

        if self.board[self.active[0], self.active[1]] == 1:
            Selection_Cross(self.active[0], self.active[1])
        elif self.board[self.active[0], self.active[1]] == 2:
            Selection_Circle(self.active[0], self.active[1])
        else:
            Selection(self.active[0], self.active[1])



    def update_board(self, position, val):
        self.board[position[0], position[1]] = val
        symbolgroup.empty()
        for i in range(9):
            for j in range(9):
                if self.board[i,j] == 1:
                    symbolgroup.add(Cross(i, j))
                elif self.board[i,j] == 2:
                    symbolgroup.add(Circle(i, j))


    def update_checkboard(self, check_new):
        self.check_board = check_new
        for i in range(3):
            for j in range(3):
                if win == 1:
                    Cross__Win_Big()
                elif self.check_board[i,j] == 1:
                    wingroup.add(Cross_Win(i, j))

                if win == 2:
                    Circle__Win_Big()
                elif self.check_board[i,j] == 2:
                    wingroup.add(Circle_Win(i, j))


    def get_active(self):
        return self.active

    def get_board(self):
        return self.board

    def get_checkboard(self):
        return self.check_board


board = Board_UI()
turn = 0
in_control = True
server_helper = 0
legal_three_by_three = [1,1]

if online:
    ready = False
    while not ready:
        try:
            status_r = requests.get('http://h.salzmannshaus.de:35880/status')
            status = json.loads(status_r.text)
            board_ = np.array(status['field'])

            for i in range(9):
                for j in range(9):
                    board.update_board([i, j], board_[i, j])
                    board.update_checkboard(check(i, j, board.get_board(), board.get_checkboard()))


            if status['player_turn'] != player_num:
                in_control = False

            turn = status['player_turn']-1

            legal_three_by_three = status['next_turn_field']



            ready = True



        except:
            #traceback.print_exc()
            pass

while ingame:
    milliseconds = clock.tick(FPS)  # do not go faster than this frame rate
    seconds = milliseconds / 1000.0
    playtime += seconds

    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            ingame = False
        elif event.type == pygame.KEYDOWN:
            if event.key == pygame.K_ESCAPE:
                ingame = False

        if event.type == pygame.KEYDOWN:
            if (event.key == pygame.K_SPACE and board.get_board()[board.get_active()[0],board.get_active()[1]] == 0 and (shrink_coordinates(board.get_active()[0], board.get_active()[1]) == legal_three_by_three)) and ((not online) or in_control):
                if online and in_control:
                    cell = board.get_active()
                    parameters = {
                        "uuid": uuid,
                        "cell": cell
                    }

                    json_par = json.dumps(parameters)


                    move = requests.get('http://h.salzmannshaus.de:35880/move', data=json_par)
                    move = json.loads(move.text)

                    print(move)

                    if move == {'error': 0}:  # move deemed OK by server
                        legal_three_by_three = [
                            shrink_coordinates(board.get_active()[0], board.get_active()[1], board.get_board())[3],
                            shrink_coordinates(board.get_active()[0], board.get_active()[1], board.get_board())[
                                2]]


                        in_control = False
                        if turn == 0:
                            board.update_board(board.get_active(), 1)

                        else:
                            board.update_board(board.get_active(), 2)

                        board.update_checkboard(
                            check(board.get_active()[0], board.get_active()[1], board.get_board(),
                                  board.get_checkboard()))

                        turn = (turn + 1) % 2

                elif not online:
                    legal_three_by_three = [
                        shrink_coordinates(board.get_active()[0], board.get_active()[1], board.get_board())[3],
                        shrink_coordinates(board.get_active()[0], board.get_active()[1], board.get_board())[
                            2]]  # remove to have fun!

                    if turn % 2 == 0:
                        board.update_board(board.get_active(), 1)

                    else:
                        board.update_board(board.get_active(), 2)

                    board.update_checkboard(
                        check(board.get_active()[0], board.get_active()[1], board.get_board(), board.get_checkboard()))

                    turn += 1


            if event.key == pygame.K_DOWN and board.get_active()[1] < 8:
                board.update_active([board.get_active()[0], board.get_active()[1] + 1])
            elif event.key == pygame.K_UP and board.get_active()[1] > 0:
                board.update_active([board.get_active()[0],board.get_active()[1]-1])



            if event.key == pygame.K_RIGHT and board.get_active()[0] < 8:
                board.update_active([board.get_active()[0]+1, board.get_active()[1]])
            elif event.key == pygame.K_LEFT and board.get_active()[0] > 0:
                board.update_active([board.get_active()[0]-1, board.get_active()[1]])

        if online and not in_control:
            if server_helper > 100:
                status_r = requests.get('XXXXXXXXXXXXXXXXXXXXXXXXX')

                status = json.loads(status_r.text)
                board_ = np.array(status['field'])
                if status['player_turn'] == player_num:
                    in_control = True
                    helper = False
                    for i in range(9):
                        for j in range(9):
                            if board_[i, j] != board.board[i, j]:
                                changed_x = i
                                changed_y = j
                                helper = True

                    if helper:
                        board.update_board([changed_x, changed_y], 1+(status['player_turn']%2))
                        turn  = status['player_turn']-1
                        board.update_checkboard(check(changed_x, changed_y, board.get_board(), board.get_checkboard()))
                        legal_three_by_three = [
                            shrink_coordinates(changed_x, changed_y, board.get_board())[3],
                            shrink_coordinates(changed_x, changed_y, board.get_board())[2]
                        ]

            server_helper = 0

    board.show_active()
    win = check_all(board.get_checkboard(), win)

    screen.fill((200,200,200))


    drawcross((34,32,52), 171, 171)
    drawcross((34,32,52), 325, 325)

    if online:
        server_helper += 1

    symbolgroup.clear(screen, screen)
    if win == 0:
        selectiongroup.update(seconds)
        selectiongroup.draw(screen)

    elif win == 1:
        Cross__Win_Big()

    else:
        Circle__Win_Big()

    symbolgroup.update(seconds)
    symbolgroup.draw(screen)
    selectiongroup.clear(screen, screen)

    wingroup.clear(screen, screen)
    wingroup.update(seconds)
    wingroup.draw(screen)
    pygame.display.update()
